
'***************
'Declare variables
'***************

Dim ScriptArray
Dim Errstring, Name, f, fc, startparams, Packagename
Dim TransformLocation, TransformYesNo, WebBrowser, InstallLocation 
Const HKEY_CURRENT_USER = &H80000001
const HKEY_LOCAL_MACHINE = &H80000002

'***************
' Set Objects
'***************

Set objArgs       = wScript.Arguments
set objshell      = wScript.createobject("wscript.shell")
set objFso        = wscript.CreateObject("scripting.FileSystemObject") 
Set wshNetwork    = Wscript.CreateObject("WScript.Network")
Set objRegistry   = GetObject("winmgmts:\\.\root\default:StdRegProv")


'****************************************
'script
'****************************************
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\windows\currentversion\Explorer\shell Folders\Local AppData")
sitecode          = objshell.ExpandEnvironmentstrings("%Temp%")
Set objFile       = objFSO.GetFile(objFSO.GetFile(Wscript.ScriptFullName).ParentFolder & "\Resources\handle.exe")
HandleshortPath   = objFile.ShortPath

'***************************************
'Determine a working location
'***************************************

strmsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\mSiCheckxmL\MSIFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")


'***************************************
'Packagename
'***************************************
'The Packagename registry key has been written by the launcher as
'the directory containing the MSI file.  This name is also used for creating a temporary folder
'that each script writes results out to.
'Before proceeding, the Packagename must be correct.

'If the default behaviour is incorrect - rewrite the packagename details 
'before proceeding
'objshell.RegWrite "HKEY_CURRENT_USER\Software\MSICheckXmL\PackageName", PackageName



'***************************************
'Delete Previous Temporary report files
'***************************************
If objFSO.FolderExists( TempDir &"\" &PackageName) then
	For Each file In objFSO.GetFolder(TempDir &"\" &PackageName).Files 
		file.attributes = file.attributes And Not 1
		file.delete
	Next
else
	objFSO.CreateFolder( TempDir &"\" &PackageName)
end if


'***************************************
'Ensure that the MSI isn't locked open
'***************************************
objshell.Run "cmd.exe /c " & HandleShortPath &" "&chr(34) &strMsiFile &chr(34) &" > "&chr(34) &TempDir &"\FileInUse.tmp" &chr(34), 2, true
Set file = objFSO.OpenTextFile(TempDir &"\FileInUse.tmp", 1,,0)

	Do While Not file.AtEndofStream
		FileLine = file.Readline
		'If the file is mentioned again in the log the file is locked....
		'Server 2008 (Probably Windows 7) can also have explorer lock the file
		If Instr(Fileline,strMsiFile ) >0 Then
			If not  Instr(Fileline,"explorer.exe") =1 then
			msgbox strMsiFile  &"Is locked open - Please close any application using the file and restart these scripts"
			wscript.quit 1
			end if
		End If
	Loop
file.Close

'**************************************************
'Create ann INFOPATH XML Header
'**************************************************

set outfile= objfso.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 2,True,-1)

outfile.writeline( "<?xml version=" &chr(34) &"1.0" &chr(34) &"?>"_
&"<?mso-infoPathSolution solutionVersion=" &chr(34) &"1.0.0.48" &chr(34) _
&" productVersion="&chr(34) &" \14.0.0" &chr(34) _
&" PIVersion="&chr(34) &"1.0.0.0" &chr(34) _
&" href=" &chr(34) &"http://www.laurierhodes.info/sites/default/files/QAResults.xsn" &chr(34) _
&" name="&chr(34) &"urn:schemas-microsoft-com:office:infopath:QAResults:-myXSD-2010-09-01T12-03-01" &chr(34) &" ?>"_
&"<?mso-application progid="&chr(34) &"InfoPath.Document"&chr(34) &"?>" _
&"<my:Report xmlns:xsi="&chr(34) &"http://www.w3.org/2001/XMLSchema-instance"&chr(34) _
&" xmlns:my="&chr(34) &"http://schemas.microsoft.com/office/infopath/2003/myXSD/2010-09-01T12:03:01" &chr(34) _
&" xmlns:xd="&chr(34) &"http://schemas.microsoft.com/office/infopath/2003" &chr(34) _
&" xml:lang="&chr(34) &"en-us"&chr(34) &">")

outfile.close

'Recurse the scripts available and run scripts
'Enumerate all the files in the current folder - This will create the script array
GetActiveScripts(objFSO.GetFile(Wscript.ScriptFullName).ParentFolder)

'setup a progress bar
Set pb = New ProgressBar
percentComplete = 0
pb.setTitle("validating")
pb.SetText("Running QA checks") 
pb.Show()

for varX = 0 to Ubound(ScriptArray)
	'Check for blank entries and ignore them
	If Len(ScriptArray(varX)) <> 0 Then
	select Case scriptArray(varx)
		Case "00_Execution.vbs"
		Case "00_Template.vbs"
		Case "MSICheckLauncher.exe"
		Case "MSICheckLauncher.pdb"	
		Case "MSICheckLauncher.vshost.exe"
		Case "MSICheckLauncher.vshost.exe.manifest"				
		Case ELSE
			objshell.run chr(34) & objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\" &ScriptArray(varX) &chr(34), 1, true
			percentComplete = (varx / Ubound(ScriptArray)) *100
			pb.Update(Round(percentComplete))
	End select
	'report = report & line & vbcrlf 
	End If
Next

'Create an XML Footer
set outfile= objfso.openTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for Append
outfile.writeline( "</my:Report>")
outfile.close
'close the progressbar 
pb.Close()

'Copy the QA document into location
'RetrievedPackageName =
objshell.RegRead("HKEY_CURRENT_USER\software\MSICheckxML\PackageName")
if RegistryItemExists ("HKEY_CURRENT_USER\Software\MSICheckXmL\ReportOverride") = True then
	ReportOverride = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\ReportOverride") 
end if
if ReportOverride="" then
	'Delete any output files
	If objFSO.FileExists(objFSO.GetFile(strMsiFile).ParentFolder &"\" &PackageName &".xml") Then 
		objFSO.DeleteFile(objFSO.GetFile(strMsiFile).ParentFolder	&"\" &PackageName &".xml")
	End if

	objFSO.MoveFile TempDir &"\" &PackageName &"\QAResult.xml" ,objFso.GetFile(strmsiFile).ParentFolder	&"\" &PackageName &".xml"
else
	If objFso.FileExists(ReportOverride &"\" &PackageName &".xml") Then 
		objFSO.DeleteFile(ReportOverride &"\" &PackageName &".xml")
	End if
	objFSO.MoveFile TempDir &"\" &PackageName &"\QAResult.xml" ,ReportOverride &"\" &PackageName &".xml"
end if

'Cleanup Objects 
Cleanup

'***********************************
' subroutines
'***********************************
Sub GetActiveScripts(strdir)
	varx=0
	set objf=objfso.GetFolder(strdir)
	set fc=objf.files 
	if fc.Count >1 then
		For each fl in fc
			varx=varx+1
		Next
		varx=varx-1
		redim ScriptArray(varx)

		'now populate the array
		varx=0
		For each fl in fc
			ScriptArray(varx) = fl.name
			varx=varx+1
		Next
	End If

	'Bubble Sort.
	for i = uBound(ScriptArray) - 1 To 0 Step -1
		for j= 0 to i
			if ScriptArray(j)>ScriptArray(j+1) then
				temp=ScriptArray(j+1) 
				scriptArray(j+1)=ScriptArray(j)
				ScriptArray(j)=temp 
			end if
		next
	next
	'end bubble sort. Thanks Richard!
end sub

Sub ProcessCommandLine()
	For I = 0 to objArgs.Count - 1
	StartParams=objArgs(I)
	StartParams=ucase(StartParams)
	SourceDir = left(startparams,instrrev(StartParams, "\"))
	
	if right(StartParams,4)=".MSI" then 
		strMsiFile = objArgs(I)
		cmdline = " " &chr(34) &strMsiFile &chr(34)
	end if
	if right(StartParams,4)=".MST" then 
		strTransormFile = objArgs(I) 
		cmdline = cmdline &" " &chr(34) &strTransormFile &chr(34)
	end if
	Next

	'Now we shell out to the launcher
	'This will write MSI & Transform file locations 
	'A launcher must be used as there is no free, file browse method available both 32bit and 64bit Windows machines
	strReturn = objshell.run( chr(34) & objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\" &"Resources\QALauncher.exe" &chr(34) &" " &cmdline, 1, true)
	if strReturn = 1 then
		WScript.Quit 0
	end if



SourceDir = Left(strMsiFile, instrrev(strFileName, "\"))

End Sub

sub cleanup
	'Set objects to Nothing Set objshell = Nothing Set objFSO = Nothing
	Set WshNetwork = Nothing 
	Set objRegistry = Nothing 
	Set Installer = Nothing 
	Set View = Nothing
	Set Record = Nothing
End Sub


'Awesome Progress bar code
Class ProgressBar
    Private m_PercentComplete
    Private m_CurrentStep
    Private m_ProgressBar
    Private m_Title
    Private m_Text
    Private m_StatusBarText
 
    'Initialize defaults
    Private Sub ProgessBar_Initialize
        m_PercentComplete = 0
        m_CurrentStep = 0
        m_Title = "Progress"
        m_Text = ""
    End Sub
 
    Public Function SetTitle(pTitle)
        m_Title = pTitle
    End Function
 
    Public Function SetText(pText)
        m_Text = pText
    End Function
 
    Public Function Update(percentComplete)
        m_PercentComplete = percentComplete
        UpdateProgressBar()
    End Function
 
    Public Function Show()
        Set m_ProgressBar = CreateObject("InternetExplorer.Application")
        'in code, the colon acts as a line feed
        m_ProgressBar.navigate2 "about:blank" : m_ProgressBar.width = 315 : m_ProgressBar.height = 40 : m_ProgressBar.toolbar = false : m_ProgressBar.menubar = false : m_ProgressBar.statusbar = false : m_ProgressBar.visible = True
        m_ProgressBar.document.write "<body Scroll=no style='margin:0px;padding:0px;'><div style='text-align:center;'><span name='pc' id='pc'>0</span></div>"
        m_ProgressBar.document.write "<div id='statusbar' name='statusbar' style='border:1px solid blue;line-height:10px;height:10px;color:blue;'></div>"
        m_ProgressBar.document.write "<div style='text-align:center'><span id='text' name='text'></span></div>"
    End Function
 
    Public Function Close()
        m_ProgressBar.quit
        'm_ProgressBar = Nothing
    End Function
 
    Private Function UpdateProgressBar()
        If m_PercentComplete = 0 Then
            m_StatusBarText = ""
        End If
        For n = m_CurrentStep to m_PercentComplete - 1
            m_StatusBarText = m_StatusBarText & "|"
            m_ProgressBar.Document.GetElementById("statusbar").InnerHtml = m_StatusBarText
            m_ProgressBar.Document.title = n & "% Complete : " & m_Title
            m_ProgressBar.Document.GetElementById("pc").InnerHtml = n & "% Complete : " & m_Title
            wscript.sleep 10
        Next
        m_ProgressBar.Document.GetElementById("statusbar").InnerHtml = m_StatusBarText
        m_ProgressBar.Document.title = m_PercentComplete & "% Complete : " & m_Title
        m_ProgressBar.Document.GetElementById("pc").InnerHtml = m_PercentComplete & "% Complete : " & m_Title
        m_ProgressBar.Document.GetElementById("text").InnerHtml = m_Text
        m_CurrentStep = m_PercentComplete
    End Function
 
 End Class

'RegistryKeyExists (Function) -1- Returns a value (true / false)
'This function checks to see if a passed registry key exists, and
'returns true if it does'
'Requirements: The registry key you are looking for (RegistryKey)
'Note: RegistryKey MUST end in a backslash (\), or FALSE will be returned 
Function RegistryKeyExists (RegistryKey)
	'Ensure the last character is a backslash (\) - if it isn't, we aren't looking for a key
	If (Right(RegistryKey, 1) <> "\") Then	'It's not a registry key we are looking for
		RegistryKeyExists = false
	Else	'If there isnt the key when we read it, it will return an error, so weneed to resume
		On Error Resume Next	'Try reading the key
		WshShell.RegRead RegistryKey
			'Catch the error
			Select Case Err	'Error Code 0 = 'success'
			Case 0:	RegistryKeyExists = true
				'This checks for the (Default) value existing (but being blank); as well as key's not existing at all (same error code)
			Case &h80070002:	'Read the error description, removing the registry key from that description
				ErrDescription = Replace(Err.description, RegistryKey, "")	'Clear the error
				Err.clear	'Read in a registry entry we know doesn't exist (to create an error description for something that doesnt exist)
				wshshell.RegRead "HKEY_ERROR\"	'The registry key exists if the error description from the HKEY_ERROR RegRead attempt doesn't match the error 'description from our RegistryKey RegRead attempt
				If (ErrDescription <> Replace(Err.description, "HKEY_ERROR\", "")) Then
					RegistryKeyExists = true 
				Else
					RegistryKeyExists = false
				End If	'Any other error code is a failure code
			Case Else:
				RegistryKeyExists = false
			End Select	'Turn error reporting back on
		On Error Goto 0
	End If
End Function

'************************************
'* Registry Item Exists (Function)
'* Returns a value (true / false)
'************************************


'This function checks to see if a passed registry key/value exists, and
'returns true if it does'
'Requirements: The registry key/value you are looking for (Registryltem) 
'Note: Registryltem MUST end in a backslash (\) if you are looking for a key Registryitem's without a backslash (\) will assume you are looking for a value

Function RegistryItemExists (Registryltem)
	'If there isnt the item when we read it, it will return an error, so we need toresume
	On Error Resume Next
	'Find out if we are looking for a key or a value
	If (Right(Registryltem, 1) = "\") Then	'It's a registry key we are lookingfor
		'Try reading the key
		wshshell.RegRead Registryltem	'Catch the error
		Select Case Err	'Error Code 0 = 'success'
			Case 0:	RegistryltemExists = true	'This checks for the (Default) value existing (but being blank); as well as key's not existing at all (same error code)
			Case &h80070002:	'Read the error description, removing the registry key from that description
				ErrDescription = Replace(Err.description, Registryltem, "")	'Clear the error
				Err.clear	'Read in a registry entry we know doesn't exist (to create an error description for something that doesnt exist)
				WshShell.RegRead "HKEY_ERROR\"	'The registry key exists if the error description from the HKEY_ERROR RegRead attempt doesn't match the error 'description from our RegistryKey RegRead attempt
				If (ErrDescription <> Replace(Err.description, "HKEY_ERROR\", "")) Then
					RegistryItemExists = true
				Else	RegistryItemExists = false
				End If	'Any other error code is a failure code
			Case Else:	RegistryItemExists = false
		End Select
	Else	'It's a registry value we are looking for	'Try reading the value
		wshshell.RegRead Registryltem	'Catch the error
		Select Case Err
		Case 0:	'Error Code 0 = 'success'
			RegistryitemExists = true
		Case Else	'Any other error code is a failure code
			RegistryItemExists = false
		End select
	End If 'Turn error reporting back on On Error Goto 0
End Function
