'****************************************
'Declare variables
'****************************************
Dim strmsiFile, strTransformFile, Appdata, PackageName 
Const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002


'****************************************
' Set Objects
'****************************************

Set objShell      = CreateObject("WScript.Shell")
set objFSO        = CreateObject("scripting.FileSystemObject") 
Set Installer     =	CreateObject("WindowsInstaller.installer")

'****************************************
' Retrieve Test Package Settings
'****************************************
strMsiFile        = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSiFile") 
strTransformFile  = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\MSTFile") 
TempDir           = objshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\Currentversion\Explorer\Shell Folders\Local Appdata")
PackageName       = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\PackageName")
Website           = objshell.RegRead("HKEY_CURRENT_USER\Software\MSICheckXML\Website")

set outfile       =	objFSO.OpenTextFile(TempDir &"\" &PackageName &"\QAResult.xml", 8,True,-1) 'open for append
Set Database      =	Installer.OpenDatabase(strMsiFile, 0)


If Not strTransformFile ="" Then 
	Database.ApplyTransform strTransformFile, 0
End if

'****************************************
'Script
'****************************************
Name			        ="" 'Friendly name of the script
ScriptPurpose	    ="" 'Ensure that the Rootdrive property is set
ScriptName		    ="" 'Actual name of the script run
ScriptResult	    =""




Set View        =	DataBase.OpenView("SELECT * FROM Property WHERE Property = 'Manufacturer'")
View.Execute
set Record      =	View.Fetch
If Not (record Is Nothing) then vendorName = Record.StringData(2) end if
Set view        =	DataBase.OpenView("SELECT * FROM Property WHERE Property = 'ProductName'")
View. Execute
Set Record      =	View.Fetch
If Not (record Is Nothing) then
	ProductName = Record.stringData(2) 
end if


'****************************************
'Results
'****************************************

outfile.writeline( "<my:Vendor>" & MakeSafe(VendorName) &"</my:Vendor>") 
outfile.writeline( "<my:AppName>" & MakeSafe(ProductName) &"</my:AppName>")
outfile.close

'****************************************
'Cleanup
'****************************************
Cleanup

'****************************************
'Functions and Subs
'****************************************

function MakeSafe(tempstring)
	tempstring = Replace (tempstring,">","&gt;") 
	tempstring = Replace (tempstring,"<","&lt;") 
	tempstring = Replace (tempstring,"&","&amp;") 
	tempstring = Replace (tempstring,"'","&apos;") 
	tempstring = Replace (tempstring,chr(34),"&quot;") 
	MakeSafe = tempstring
end function

sub Cleanup
	'Set Objects to Nothing 
	Set objShell    =	Nothing
	Set wshNetwork 	= Nothing
	Set Installer 	= Nothing
	Set View 		    = Nothing
	set Record 		  = Nothing
End Sub
